/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ANALYZE = 258,
     ARCHIVE = 259,
     COPY = 260,
     EOL = 261,
     FILTER = 262,
     HUP = 263,
     LOG = 264,
     RESTART = 265,
     RUN = 266,
     SET = 267,
     STOP = 268,
     TRUNCATE = 269,
     EQ = 270,
     LBRACE = 271,
     RBRACE = 272,
     LABEL = 273,
     STRING = 274,
     VALUE = 275,
     VARIABLE = 276,
     NUMBER = 277
   };
#endif
#define ANALYZE 258
#define ARCHIVE 259
#define COPY 260
#define EOL 261
#define FILTER 262
#define HUP 263
#define LOG 264
#define RESTART 265
#define RUN 266
#define SET 267
#define STOP 268
#define TRUNCATE 269
#define EQ 270
#define LBRACE 271
#define RBRACE 272
#define LABEL 273
#define STRING 274
#define VALUE 275
#define VARIABLE 276
#define NUMBER 277




/* Copy the first part of user declarations.  */
#line 1 "cfgparse.y"

/* $Id: cfgparse.y 207 2005-10-12 22:46:44Z rra $

   Parse the configuration file.

   Written by Russ Allbery <rra@stanford.edu>
   Copyright 1998, 1999, 2000, 2002
       Board of Trustees, Leland Stanford Jr. University

   This program is free software.  See README included in the distribution
   for terms and conditions.

   Parse the configuration file.  Our end product is a linked list of log
   classes, which the rest of newsyslog will use as data to do the actual
   work (see logs.h for the definitions of all of the relevant structs).
   The input stream comes from the lexer.

   Be warned:  We're pretty much relying on bison here because it makes the
   make process so much easier.  I don't think I'm doing anything
   bison-specific in this, but I'm also not testing against yacc regularly.
   So you may have to use bison. */

#include "system.h"
#include "expand.h"
#include "logs.h"
#include "utility.h"

#include <grp.h>
#include <pwd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* We want to have verbose parse error messages. */
#define YYERROR_VERBOSE 1

/* These two functions need to be externally visible. */
void cfgdie(const char *format, ...);
void yyerror(const char *error);

/* This comes from cfgtoken.l and lex. */ 
int yylex(void); 

/* Stuff for internal use only. */
static struct archive *archive(char *template, int count);
static char *cfgexpand(char *string, const char *name);
static char *lookup(char *path);
static void set(char *name, const char *content);
static struct log *merge (struct log *logs, struct log *actions);

/* The FILE that our lexer will read from. */
extern FILE *yyin;

/* The current line of our configuration file (maintained by the lexer). */
extern int cfgline; 

/* Struct to store variable content mappings from set commands. */
struct variable {
    char *name;
    const char *content;
    struct variable *next;
};

/* Stores a linked list of all variables that have been set. */
static struct variable *variables = NULL;
  
/* The final result of our parsing, a linked list of classes. */
static struct class *class;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 74 "cfgparse.y"
typedef union YYSTYPE {
    char *string;
    int number;
    struct command *command;
    struct process *process;
    struct log *log;
    struct class *class;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 200 "cfgparse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 212 "cfgparse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  11
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   54

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  23
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  22
/* YYNRULES -- Number of rules. */
#define YYNRULES  36
/* YYNRULES -- Number of states. */
#define YYNSTATES  73

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   277

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     9,    12,    15,    16,    19,    21,    23,
      27,    28,    32,    33,    35,    37,    39,    41,    43,    52,
      53,    58,    63,    69,    74,    78,    80,    82,    84,    86,
      88,    91,    92,   100,   103,   106,   107
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      44,     0,    -1,    12,    21,    15,    19,     6,    -1,     8,
      19,    -1,    26,    19,    -1,    -1,    11,    26,    -1,    25,
      -1,    27,    -1,    13,    28,     6,    -1,    -1,    10,    28,
       6,    -1,    -1,    22,    -1,    19,    -1,    22,    -1,    19,
      -1,    19,    -1,     9,    33,    19,    31,    32,    22,     6,
      34,    -1,    -1,     3,    33,    26,     6,    -1,     7,    33,
      26,     6,    -1,     4,    33,    19,    22,     6,    -1,     5,
      33,    19,     6,    -1,    14,    33,     6,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    39,    -1,    40,    41,
      -1,    -1,    18,    16,    29,    30,    34,    41,    17,    -1,
      24,    43,    -1,    42,    43,    -1,    -1,    43,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   151,   151,   154,   187,   211,   223,   234,   235,   238,
     239,   242,   243,   246,   247,   261,   262,   279,   293,   319,
     322,   332,   342,   353,   363,   374,   375,   376,   377,   378,
     381,   389,   392,   408,   409,   417,   420
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ANALYZE", "ARCHIVE", "COPY", "EOL",
  "FILTER", "HUP", "LOG", "RESTART", "RUN", "SET", "STOP", "TRUNCATE",
  "\"=\"", "\"{\"", "\"}\"", "LABEL", "STRING", "VALUE", "VARIABLE",
  "NUMBER", "$accept", "set", "hup", "arguments", "run", "process", "stop",
  "restart", "uid", "gid", "log", "logs", "analyze", "filter", "archive",
  "copy", "truncate", "action", "actions", "block", "class", "file", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    23,    24,    25,    26,    26,    27,    28,    28,    29,
      29,    30,    30,    31,    31,    32,    32,    33,    34,    34,
      35,    36,    37,    38,    39,    40,    40,    40,    40,    40,
      41,    41,    42,    43,    43,    43,    44
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     5,     2,     2,     0,     2,     1,     1,     3,
       0,     3,     0,     1,     1,     1,     1,     1,     8,     0,
       4,     4,     5,     4,     3,     1,     1,     1,     1,     1,
       2,     0,     7,     2,     2,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      35,     0,     0,    35,    35,    36,     0,     0,    10,    33,
      34,     1,     0,     0,    12,     0,     0,     5,     7,     8,
       0,     0,    19,     2,     3,     6,     9,     0,     0,    31,
       4,    11,    17,     0,     0,     0,     0,     0,     0,    25,
      27,    26,    28,    29,    31,     0,     0,     5,     0,     0,
       5,     0,    30,    32,    14,    13,     0,     0,     0,     0,
       0,    24,    16,    15,     0,    20,     0,    23,    21,     0,
      22,    19,    18
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     3,    18,    25,    19,    20,    14,    22,    56,    64,
      33,    29,    39,    40,    41,    42,    43,    44,    45,     4,
       5,     6
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -25
static const yysigned_char yypact[] =
{
      -9,   -19,    11,    -9,    -9,   -25,    28,    14,    17,   -25,
     -25,   -25,    12,    -1,    22,    27,    15,   -25,   -25,   -25,
      29,    -1,    30,   -25,   -25,    18,   -25,    32,    21,     1,
     -25,   -25,   -25,    23,    21,    21,    21,    21,    21,   -25,
     -25,   -25,   -25,   -25,     1,    19,     2,   -25,    24,    25,
     -25,    35,   -25,   -25,   -25,   -25,     3,    -6,    26,    39,
      -5,   -25,   -25,   -25,    31,   -25,    40,   -25,   -25,    41,
     -25,    30,   -25
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -25,   -25,   -25,   -24,   -25,    33,   -25,   -25,   -25,   -25,
     -18,   -22,   -25,   -25,   -25,   -25,   -25,   -25,     6,   -25,
       8,   -25
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      65,    68,     7,     1,    34,    35,    36,    16,    37,     2,
      17,     9,    10,    30,    30,    38,    47,    48,    49,    50,
      51,    54,    62,    57,    55,    63,    60,     8,    11,    12,
      13,    15,    21,    23,    24,    26,    53,    30,    31,    28,
      32,    61,    46,    58,    59,    67,    70,    71,    66,    72,
      52,     0,     0,    69,    27
};

static const yysigned_char yycheck[] =
{
       6,     6,    21,    12,     3,     4,     5,     8,     7,    18,
      11,     3,     4,    19,    19,    14,    34,    35,    36,    37,
      38,    19,    19,    47,    22,    22,    50,    16,     0,    15,
      13,    19,    10,     6,    19,     6,    17,    19,     6,     9,
      19,     6,    19,    19,    19,     6,     6,     6,    22,    71,
      44,    -1,    -1,    22,    21
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    12,    18,    24,    42,    43,    44,    21,    16,    43,
      43,     0,    15,    13,    29,    19,     8,    11,    25,    27,
      28,    10,    30,     6,    19,    26,     6,    28,     9,    34,
      19,     6,    19,    33,     3,     4,     5,     7,    14,    35,
      36,    37,    38,    39,    40,    41,    19,    33,    33,    33,
      33,    33,    41,    17,    19,    22,    31,    26,    19,    19,
      26,     6,    19,    22,    32,     6,    22,     6,     6,    22,
       6,     6,    34
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 151 "cfgparse.y"
    { set(yyvsp[-3].string, yyvsp[-1].string); ;}
    break;

  case 3:
#line 155 "cfgparse.y"
    {
                      struct process *process;
                    
                      process = xmalloc(sizeof(struct process));
                      process->command = NULL;
                      process->pidfile = cfgexpand(yyvsp[0].string, "");
                      yyval.process = process;
                  ;}
    break;

  case 4:
#line 188 "cfgparse.y"
    {
                      struct command *command = yyvsp[-1].command;
                      int size;

                      /* Check to see if we need to grow our array.  Note
                         that the size has to be *larger* than argc so that
                         we have room for the terminating NULL. */
                      command->argc++;
                      if (command->argc >= command->size) {
                          command->size *= 2;
                          size = command->size * sizeof(char *);
                          command->argv = xrealloc(command->argv, size);
                      }

                      /* Aesthetically, the "name" argument of expand()
                         should probably be the block label, but we don't
                         have easy access to that here and my sense of
                         aesthetics isn't strong enough to get me to
                         restructure code to get at it.... */
                      command->argv[command->argc - 1] = cfgexpand (yyvsp[0].string, "");
                      command->argv[command->argc] = NULL;
                  ;}
    break;

  case 5:
#line 211 "cfgparse.y"
    {
                      struct command *command;
                    
                      command = xmalloc(sizeof(struct command));
                      command->argc = 0;
                      command->size = 3;
                      command->argv = xmalloc(3 * sizeof (char *));
                      command->next = NULL;
                      yyval.command = command;
                  ;}
    break;

  case 6:
#line 224 "cfgparse.y"
    {
                    struct process *process;
                  
                    process = xmalloc(sizeof(struct process));
                    process->command = yyvsp[0].command;
                    process->pidfile = NULL;
                    yyval.process = process;
                ;}
    break;

  case 7:
#line 234 "cfgparse.y"
    { yyval.process = yyvsp[0].process; ;}
    break;

  case 8:
#line 235 "cfgparse.y"
    { yyval.process = yyvsp[0].process; ;}
    break;

  case 9:
#line 238 "cfgparse.y"
    { yyval.process = yyvsp[-1].process; ;}
    break;

  case 10:
#line 239 "cfgparse.y"
    { yyval.process = NULL; ;}
    break;

  case 11:
#line 242 "cfgparse.y"
    { yyval.process = yyvsp[-1].process; ;}
    break;

  case 12:
#line 243 "cfgparse.y"
    { yyval.process = NULL; ;}
    break;

  case 13:
#line 246 "cfgparse.y"
    { yyval.number = yyvsp[0].number; ;}
    break;

  case 14:
#line 248 "cfgparse.y"
    {
                      struct passwd *pw;

                      pw = getpwnam(yyvsp[0].string);
                      if (pw) {
                          free(yyvsp[0].string);
                          yyval.number = pw->pw_uid;
                      } else {
                          cfgdie("Unknown user %s", yyvsp[0].string);
                      }
                  ;}
    break;

  case 15:
#line 261 "cfgparse.y"
    { yyval.number = yyvsp[0].number; ;}
    break;

  case 16:
#line 263 "cfgparse.y"
    {
                      struct group *gr;

                      gr = getgrnam(yyvsp[0].string);
                      if (gr) {
                          free(yyvsp[0].string);
                          yyval.number = gr->gr_gid;
                      } else {
                          cfgdie("Unknown group %s", yyvsp[0].string);
                      }
                  ;}
    break;

  case 17:
#line 280 "cfgparse.y"
    {
                      struct log *log;

                      log = xmalloc(sizeof(struct log));
                      log->name = yyvsp[0].string;
                      log->rotate = false;
                      log->analyze = NULL;
                      log->archive = NULL;
                      log->filter = NULL;
                      yyval.log = log;
                  ;}
    break;

  case 18:
#line 294 "cfgparse.y"
    {
                      struct log *log;
                      int mode, factor;

                      log = yyvsp[-6].log;
                      log->path = cfgexpand(lookup(yyvsp[-5].string), log->name);
                      log->tmppath = NULL;
                      log->owner = (uid_t) yyvsp[-4].number;
                      log->group = (gid_t) yyvsp[-3].number;
                      mode = yyvsp[-2].number;

                      /* Interpret the permissions as octal.  Roll our own
                         converter to avoid needless weird library calls. */
                      factor = 1;
                      log->mode = 0;
                      while (mode > 0) {
                          log->mode += (mode % 10) * factor;
                          factor *= 8;
                          mode /= 10;
                      }

                      /* Return a linked list of what we've seen so far. */
                      log->next = yyvsp[0].log;
                      yyval.log = log;
                  ;}
    break;

  case 19:
#line 319 "cfgparse.y"
    { yyval.log = NULL; ;}
    break;

  case 20:
#line 323 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-2].log;
                      log->analyze = yyvsp[-1].command;
                      yyval.log = log;
                  ;}
    break;

  case 21:
#line 333 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-2].log;
                      log->filter = yyvsp[-1].command;
                      yyval.log = log;
                  ;}
    break;

  case 22:
#line 343 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-3].log;
                      log->archive = archive(yyvsp[-2].string, yyvsp[-1].number);
                      log->rotate = true;
                      yyval.log = log;
                  ;}
    break;

  case 23:
#line 354 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-2].log;
                      log->archive = archive(yyvsp[-1].string, -1);
                      yyval.log = log;
                  ;}
    break;

  case 24:
#line 364 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-1].log;
                      log->archive = archive(NULL, -1);
                      log->rotate = true;
                      yyval.log = log;
                  ;}
    break;

  case 25:
#line 374 "cfgparse.y"
    { yyval.log = yyvsp[0].log; ;}
    break;

  case 26:
#line 375 "cfgparse.y"
    { yyval.log = yyvsp[0].log; ;}
    break;

  case 27:
#line 376 "cfgparse.y"
    { yyval.log = yyvsp[0].log; ;}
    break;

  case 28:
#line 377 "cfgparse.y"
    { yyval.log = yyvsp[0].log; ;}
    break;

  case 29:
#line 378 "cfgparse.y"
    { yyval.log = yyvsp[0].log; ;}
    break;

  case 30:
#line 382 "cfgparse.y"
    {
                      struct log *log;

                      log = yyvsp[-1].log;
                      log->next = yyvsp[0].log;
                      yyval.log = log;
                  ;}
    break;

  case 31:
#line 389 "cfgparse.y"
    { yyval.log = NULL; ;}
    break;

  case 32:
#line 393 "cfgparse.y"
    {
                      struct class *block;

                      block = xmalloc(sizeof(struct class));
                      block->name = yyvsp[-6].string;
                      block->stop = yyvsp[-4].process;
                      block->restart = yyvsp[-3].process;
                      block->logs = merge(yyvsp[-2].log, yyvsp[-1].log);
                      yyval.class = block;
                  ;}
    break;

  case 33:
#line 408 "cfgparse.y"
    { yyval.class = yyvsp[0].class; ;}
    break;

  case 34:
#line 410 "cfgparse.y"
    {
                      struct class *block;

                      block = yyvsp[-1].class;
                      block->next = yyvsp[0].class;
                      yyval.class = block;
                  ;}
    break;

  case 35:
#line 417 "cfgparse.y"
    { yyval.class = NULL; ;}
    break;

  case 36:
#line 420 "cfgparse.y"
    { class = yyvsp[0].class; ;}
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1472 "cfgparse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 423 "cfgparse.y"


/* yyerror() is just a simple wrapper around cfgdie(). */
void
yyerror(const char *error) {
    cfgdie(error);
}


/* Prepend the current line number to the error message before dying.  This
   needs to not be a static function so that the lexer can pull it in and
   use it as well. */
void
cfgdie(const char *format, ...)
{
    va_list message;

    fprintf(stderr, "config line %d: ", cfgline);
    va_start(message, format);
    vfprintf(stderr, format, message);
    va_end(message);
    fprintf(stderr, "\n");
    exit(1);
}

   
/* We maintain a linked list of variables that have been set, which is used
   later by lookup() when it does variable expansion.  Note that we don't
   check for duplicates; this is intentional, as we want to allow people to
   redefine variables.  We add all new definitions onto the *beginning* of
   the linked list, and then any subsequent lookups will always find the
   latest definition of a variable. */
static void
set(char *name, const char *content)
{
    struct variable *variable;

    /* Allocate a new struct variable and add it to the linked list. */
    variable = xmalloc(sizeof(struct variable));
    variable->name = name;
    variable->content = content;
    variable->next = variables ? variables : NULL;
    variables = variable;
}


/* Given an argument that's supposed to be a path, run it through variable
   expansion if it doesn't start with a slash.  Stuff starting with a slash
   bypasses this entirely; it's somewhat counterintuitive that we still call
   lookup for things that we're not going to look up in the variable table,
   but it made the code neater.  We're being passed in a malloc'd string; if
   we return a variable value (also a malloc'd string, stored in the linked
   list of variables), be sure to free our argument. */
static char *
lookup(char *path)
{
    struct variable *variable;
    char *value;
  
    if (path[0] != '/' && strncmp(path, "./", 2) != 0) {
        for (variable = variables; variable; variable = variable->next)
            if (!strcmp(variable->name, path))
                break;
        if (!variable)
            cfgdie("Undefined variable %s", path);
        free(path);
        value = xmalloc(strlen(variable->content) + 1);
        strcpy(value, variable->content);
        return value;
    } else {
        return path;
    }
}


/* Check over a string for the invalid %s escape and then pass it along to
   expand() so that % expansion can be done.  The time passed to it will be
   0 (indicating to use the current time).  Returns NULL on error.  We free
   the string passed in and return the malloc'd string that expand()
   returns. */
static char *
cfgexpand(char *string, const char *name)
{
    char *p;

    /* Check for invalid % escapes. */
    for (p = string; *p; p++)
        if (*p == '%' && !(*(++p) && strchr("%dmnDMY", *p)))
            cfgdie("Invalid %% escape");

    /* Okay, valid format.  Send it through the real expand(). */
    p = expand(string, name, 0);
    if (p == NULL)
        cfgdie("Unable to expand string");
    free(string);
    return p;
}


/* Construct an archive struct, given a template or variable containing a
   template and the number of old logs to save as arguments.  We allocate a
   new struct archive and return it. */
static struct archive *
archive(char *template, int count)
{
    struct archive *new;
    char *location;
    int length;

    /* Allocate a new archive struct and initialize it. */
    new = xmalloc(sizeof(struct archive));
    new->count = count;
    new->path = NULL;
    new->next = NULL;

    /* Now massage the template according to rotation policy. */
    if (template == NULL)
        new->template = NULL;
    else {
        location = lookup(template);
        length = strlen(location) + 4 + use_bzip2;
        if (count > 0)
            length += 2;
        new->template = xmalloc(length);
        strcpy(new->template, location);
        if (count > 0)
            strcat(new->template, ".0");
        strcat(new->template, use_bzip2 ? ".bz2" : ".gz");
        free(location);
    }

    /* Return the completed archive struct. */
    return new;
}


/* When we originally generated the list of logs and the list of actions, we
   did so as two separate linked lists of logs, as it was easier to convince
   yacc/bison to cope with that.  See the long comments at the top of the
   grammer.  This merges them back together.

   We take two pointers to linked lists of logs; the first will be correct for
   path, owner, group, and mode, and the second will have archive, rotate,
   analyze, and filter elements filled in.  We return a single pointer to a
   linked list of logs with no duplicates that has everything merged together.

   We have not previously checked to see if we have any duplicate log
   definitions, so we also check this while we're at it.  We call cfgdie()
   on any errors (rather than yyerror(), which can't take variable
   arguments). */
static struct log *
merge(struct log *logs, struct log *actions)
{
    struct log *current, *log, *old;
    struct archive *last;
    struct command *command;
  
    /* Scan logs and make sure that there aren't any duplicates. */
    for (current = logs; current != NULL && current->next != NULL;
         current = current->next)
        for (log = current->next; log != NULL; log = log->next)
            if (strcmp(current->name, log->name) == 0)
                cfgdie("Duplicate log definition for %s", current->name);

    /* Now, step through the actions one at a time, merging their contents
       into logs and freeing the memory used by the actions.  Here's where
       we detect people assigning actions to logs that were never existed,
       so those errors will show up as being at the end of the log class
       block rather than at the archive line itself.  Hurm. */
    for (current = actions; current; ) {
        for (log = logs; log != NULL; log = log->next)
            if (strcmp(log->name, current->name) == 0)
                break;
        if (!log)
            cfgdie("Unknown log %s", current->name);
        if (log->archive) {
            for (last = log->archive; last->next != NULL; last = last->next)
                ;
            last->next = current->archive;
        } else {
            log->archive = current->archive;
        }
        if (log->analyze) {
            for (command = log->analyze; command->next != NULL;
                 command = command->next)
                ;
            command->next = current->analyze;
        } else {
            log->analyze = current->analyze;
        }
        if (log->filter)
            cfgdie("Duplicate filter actions for %s", current->name);
        else
            log->filter = current->filter;
        log->rotate = current->rotate || log->rotate;
        old = current;
        current = current->next;
        free(old->name);
        free(old);
    }

    /* Return the linked list of combined log structs. */
    return logs;
}


/* This is the function that the rest of the world gets to call.  It takes
   in the name of the configuration file, and returns a pointer to a linked
   list of class structs. */
struct class *
read_config(const char *filename)
{
    FILE *config;

    /* Attempt to open our configuration file. */
    config = fopen(filename, "r");
    if (!config)
        die("Cannot open configuration file %s", filename);

    /* Point our lexer at the right file, and then let magic happen. */
    yyin = config;
    if (yyparse())
        die("Parsing of %s failed", filename);
    fclose(config);
    return class;
}

